Loading...
Searching...
No Matches
Sip_proxy_authenticate

## Macros

#define | sip_proxy_authenticate(sip)
| Access a SIP Proxy-Authenticate header structure sip_proxy_authenticate_t from sip_t.
#define | SIP_PROXY_AUTHENTICATE_INIT()
| Initializer for structure sip_proxy_authenticate_t.
#define | SIPTAG_PROXY_AUTHENTICATE(x)
| Tag list item for pointer to a Proxy-Authenticate header structure sip_proxy_authenticate_t.
#define | SIPTAG_PROXY_AUTHENTICATE_REF(x)
| Tag list item for reference to a Proxy-Authenticate header pointer.
#define | SIPTAG_PROXY_AUTHENTICATE_STR(s)
| Tag list item for string with Proxy-Authenticate header value.
#define | SIPTAG_PROXY_AUTHENTICATE_STR_REF(x)
| Tag list item for reference to a Proxy-Authenticate header string.

## Typedefs

typedef struct msg_auth_s | sip_proxy_authenticate_t
| @

## Functions

issize_t | sip_proxy_authenticate_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Proxy-Authenticate header.
issize_t | sip_proxy_authenticate_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Proxy-Authenticate header.
sip_proxy_authenticate_t * | sip_proxy_authenticate_init (sip_proxy_authenticate_t x[1])
| Initialize a structure sip_proxy_authenticate_t.
int | sip_is_proxy_authenticate (sip_header_t const *header)
| Test if header object is instance of sip_proxy_authenticate_t.
sip_proxy_authenticate_t * | sip_proxy_authenticate_dup (su_home_t *home, sip_proxy_authenticate_t const *hdr))
| Duplicate a list of Proxy-Authenticate header header structures sip_proxy_authenticate_t.
sip_proxy_authenticate_t * | sip_proxy_authenticate_copy (su_home_t *home, sip_proxy_authenticate_t const *hdr))
| Copy a list of Proxy-Authenticate header header structures sip_proxy_authenticate_t.
sip_proxy_authenticate_t * | sip_proxy_authenticate_make (su_home_t *home, char const *s))
| Make a Proxy-Authenticate header structure sip_proxy_authenticate_t.
sip_proxy_authenticate_t * | sip_proxy_authenticate_format (su_home_t *home, char const *fmt,...)))
| Make a Proxy-Authenticate header from formatting result.

## Variables

msg_hclass_t | sip_proxy_authenticate_class []
| Header class for Proxy-Authenticate header.
tag_typedef_t | siptag_proxy_authenticate
| Tag for Proxy-Authenticate header object.
tag_typedef_t | siptag_proxy_authenticate_str
| Tag for string with Proxy-Authenticate header value.

## Detailed Description

## Macro Definition Documentation

## SIP_PROXY_AUTHENTICATE_INIT

#define SIP_PROXY_AUTHENTICATE_INIT | ( |  | ) |

Initializer for structure sip_proxy_authenticate_t.

A static sip_proxy_authenticate_t structure for Proxy-Authenticate header must be initialized with the SIP_PROXY_AUTHENTICATE_INIT() macro. For instance,

sip_proxy_authenticate_t sip_proxy_authenticate = SIP_PROXY_AUTHENTICATE_INIT;
SIP_PROXY_AUTHENTICATE_INIT
#define SIP_PROXY_AUTHENTICATE_INIT()
Initializer for structure sip_proxy_authenticate_t.
Definition sip_protos.h:9430
sip_proxy_authenticate_t
struct msg_auth_s sip_proxy_authenticate_t
@
Definition sip.h:167
sip_proxy_authenticate
#define sip_proxy_authenticate(sip)
Access a SIP Proxy-Authenticate header structure sip_proxy_authenticate_t from sip_t.
Definition sip_protos.h:9413

## SIPTAG_PROXY_AUTHENTICATE

#define SIPTAG_PROXY_AUTHENTICATE | ( |  | x | ) |

Tag list item for pointer to a Proxy-Authenticate header structure sip_proxy_authenticate_t.

The SIPTAG_PROXY_AUTHENTICATE() macro is used to include a tag item with a pointer to a sip_proxy_authenticate_t structure in a tag list.

Parameters

  x | pointer to a sip_proxy_authenticate_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_PROXY_AUTHENTICATE_REF().

## SIPTAG_PROXY_AUTHENTICATE_STR

#define SIPTAG_PROXY_AUTHENTICATE_STR | ( |  | s | ) |

Tag list item for string with Proxy-Authenticate header value.

The SIPTAG_PROXY_AUTHENTICATE_STR() macro is used to include a tag item with a string containing value of a sip_proxy_authenticate_t header in a tag list.

Parameters

  s | pointer to a string containing Proxy-Authenticate header value, or NULL.

The string in SIPTAG_PROXY_AUTHENTICATE_STR() can be converted to a sip_proxy_authenticate_t header structure by giving the string s has second argument to function sip_proxy_authenticate_make().

The corresponding tag taking reference parameter is SIPTAG_PROXY_AUTHENTICATE_STR_REF().

## Typedef Documentation

## sip_proxy_authenticate_t

typedef struct msg_auth_s sip_proxy_authenticate_t

@

The Proxy-Authenticate header consists of a challenge that indicates the authentication scheme and parameters applicable to the proxy. Its syntax is defined in [H14.33, S10.31] as follows:

Proxy-Authenticate = "Proxy-Authenticate" HCOLON challenge
challenge = ("Digest" LWS digest-cln *(COMMA digest-cln))
/ other-challenge
other-challenge = auth-scheme LWS auth-param
*(COMMA auth-param)
digest-cln = realm / domain / nonce
/ opaque / stale / algorithm
/ qop-options / auth-param
realm = "realm" EQUAL realm-value
realm-value = quoted-string
domain = "domain" EQUAL LDQUOT URI
*( 1*SP URI ) RDQUOT
URI = absoluteURI / abs-path
nonce = "nonce" EQUAL nonce-value
nonce-value = quoted-string
opaque = "opaque" EQUAL quoted-string
stale = "stale" EQUAL ( "true" / "false" )
algorithm = "algorithm" EQUAL ( "MD5" / "MD5-sess"
/ token )
qop-options = "qop" EQUAL LDQUOT qop-value
*("," qop-value) RDQUOT
qop-value = "auth" / "auth-int" / token
LWS
#define LWS
SP
#define SP

The parsed Proxy-Authenticate header is stored in sip_proxy_authenticate_t structure.

The structure sip_proxy_authenticate_t contains representation of SIP Proxy-Authenticate header.

The sip_proxy_authenticate_t is defined as follows:

typedef struct msg_auth_s {
msg_common_t au_common[1]; // Common fragment info
msg_auth_t *au_next; // Link to next header
char const *au_scheme; // Auth-scheme like "Basic" or "Digest"
msg_param_t const *au_params; // Comma-separated parameters
} sip_proxy_authenticate_t;
msg_common_t
struct msg_common_s msg_common_t
msg_auth_s
msg_auth_s::au_scheme
char const * au_scheme
msg_auth_s::au_params
msg_param_t const * au_params
msg_auth_s::au_next
msg_auth_t * au_next
msg_auth_s::au_common
msg_common_t au_common[1]

## Function Documentation

## sip_is_proxy_authenticate()

int sip_is_proxy_authenticate | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_proxy_authenticate_t.

Check if the header class is an instance of Proxy-Authenticate header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header proxy_authenticate
  0 | (false) otherwise

## sip_proxy_authenticate_copy()

sip_proxy_authenticate_t * sip_proxy_authenticate_copy | ( | su_home_t * | home,
|  | sip_proxy_authenticate_t const * | hdr )

inline

Copy a list of Proxy-Authenticate header header structures sip_proxy_authenticate_t.

The function sip_proxy_authenticate_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  proxy_authenticate = sip_proxy_authenticate_copy(home, sip->sip_proxy_authenticate);
  sip_proxy_authenticate_copy
  sip_proxy_authenticate_t * sip_proxy_authenticate_copy(su_home_t *home, sip_proxy_authenticate_t const *hdr))
  Copy a list of Proxy-Authenticate header header structures sip_proxy_authenticate_t.
  Definition sip_protos.h:9560

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_proxy_authenticate_dup()

sip_proxy_authenticate_t * sip_proxy_authenticate_dup | ( | su_home_t * | home,
|  | sip_proxy_authenticate_t const * | hdr )

inline

Duplicate a list of Proxy-Authenticate header header structures sip_proxy_authenticate_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  proxy_authenticate = sip_proxy_authenticate_dup(home, sip->sip_proxy_authenticate);
  sip_proxy_authenticate_dup
  sip_proxy_authenticate_t * sip_proxy_authenticate_dup(su_home_t *home, sip_proxy_authenticate_t const *hdr))
  Duplicate a list of Proxy-Authenticate header header structures sip_proxy_authenticate_t.
  Definition sip_protos.h:9517

Returns
  A pointer to the newly duplicated sip_proxy_authenticate_t header structure, or NULL upon an error.

## sip_proxy_authenticate_format()

sip_proxy_authenticate_t * sip_proxy_authenticate_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Proxy-Authenticate header from formatting result.

Make a new sip_proxy_authenticate_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_proxy_authenticate_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_proxy_authenticate_init()

sip_proxy_authenticate_t * sip_proxy_authenticate_init | ( | sip_proxy_authenticate_t | x[1] | ) |

inline

Initialize a structure sip_proxy_authenticate_t.

An sip_proxy_authenticate_t structure for Proxy-Authenticate header can be initialized with the sip_proxy_authenticate_init() function/macro. For instance,

sip_proxy_authenticate_t sip_proxy_authenticate;
sip_proxy_authenticate_init(&sip_proxy_authenticate);
sip_proxy_authenticate_init
sip_proxy_authenticate_t * sip_proxy_authenticate_init(sip_proxy_authenticate_t x[1])
Initialize a structure sip_proxy_authenticate_t.
Definition sip_protos.h:9448

## sip_proxy_authenticate_make()

sip_proxy_authenticate_t * sip_proxy_authenticate_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Proxy-Authenticate header structure sip_proxy_authenticate_t.

The function sip_proxy_authenticate_make() makes a new sip_proxy_authenticate_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_proxy_authenticate_t header structure, or NULL upon an error.

## Variable Documentation

## sip_proxy_authenticate_class

msg_hclass_t sip_proxy_authenticate_class[]

extern

Header class for Proxy-Authenticate header.

The header class sip_proxy_authenticate_class defines how a SIP Proxy-Authenticate header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_proxy_authenticate_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.